# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Connection do
  @moduledoc """
  Handle Tesla connections for GoogleApi.People.V1.
  """

  @type t :: Tesla.Env.client()

  use GoogleApi.Gax.Connection,
    scopes: [
      # See, edit, download, and permanently delete your contacts
      "https://www.googleapis.com/auth/contacts",

      # See and download contact info automatically saved in your "Other contacts"
      "https://www.googleapis.com/auth/contacts.other.readonly",

      # See and download your contacts
      "https://www.googleapis.com/auth/contacts.readonly",

      # See and download your organization's GSuite directory
      "https://www.googleapis.com/auth/directory.readonly",

      # View your street addresses
      "https://www.googleapis.com/auth/user.addresses.read",

      # See and download your exact date of birth
      "https://www.googleapis.com/auth/user.birthday.read",

      # See and download all of your Google Account email addresses
      "https://www.googleapis.com/auth/user.emails.read",

      # See your gender
      "https://www.googleapis.com/auth/user.gender.read",

      # See your education, work history and org info
      "https://www.googleapis.com/auth/user.organization.read",

      # See and download your personal phone numbers
      "https://www.googleapis.com/auth/user.phonenumbers.read",

      # See your primary Google Account email address
      "https://www.googleapis.com/auth/userinfo.email",

      # See your personal info, including any personal info you've made publicly available
      "https://www.googleapis.com/auth/userinfo.profile"
    ],
    otp_app: :google_api_people,
    base_url: "https://people.googleapis.com/"
end
