# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.BatchUpdateContactsRequest do
  @moduledoc """
  A request to update a batch of contacts.

  ## Attributes

  *   `contacts` (*type:* `%{optional(String.t) => GoogleApi.People.V1.Model.Person.t}`, *default:* `nil`) - Required. A map of resource names to the person data to be updated. Allows up to 200 contacts in a single request.
  *   `readMask` (*type:* `String.t`, *default:* `nil`) - Required. A field mask to restrict which fields on each person are returned. Multiple fields can be specified by separating them with commas. If read mask is left empty, the post-mutate-get is skipped and no data will be returned in the response. Valid values are: * addresses * ageRanges * biographies * birthdays * calendarUrls * clientData * coverPhotos * emailAddresses * events * externalIds * genders * imClients * interests * locales * locations * memberships * metadata * miscKeywords * names * nicknames * occupations * organizations * phoneNumbers * photos * relations * sipAddresses * skills * urls * userDefined
  *   `sources` (*type:* `list(String.t)`, *default:* `nil`) - Optional. A mask of what source types to return. Defaults to READ_SOURCE_TYPE_CONTACT and READ_SOURCE_TYPE_PROFILE if not set.
  *   `updateMask` (*type:* `String.t`, *default:* `nil`) - Required. A field mask to restrict which fields on the person are updated. Multiple fields can be specified by separating them with commas. All specified fields will be replaced, or cleared if left empty for each person. Valid values are: * addresses * biographies * birthdays * calendarUrls * clientData * emailAddresses * events * externalIds * genders * imClients * interests * locales * locations * memberships * miscKeywords * names * nicknames * occupations * organizations * phoneNumbers * relations * sipAddresses * urls * userDefined
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :contacts => %{optional(String.t()) => GoogleApi.People.V1.Model.Person.t()} | nil,
          :readMask => String.t() | nil,
          :sources => list(String.t()) | nil,
          :updateMask => String.t() | nil
        }

  field(:contacts, as: GoogleApi.People.V1.Model.Person, type: :map)
  field(:readMask)
  field(:sources, type: :list)
  field(:updateMask)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.BatchUpdateContactsRequest do
  def decode(value, options) do
    GoogleApi.People.V1.Model.BatchUpdateContactsRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.BatchUpdateContactsRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
