# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.ContactGroup do
  @moduledoc """
  A contact group.

  ## Attributes

  *   `clientData` (*type:* `list(GoogleApi.People.V1.Model.GroupClientData.t)`, *default:* `nil`) - The group's client data.
  *   `etag` (*type:* `String.t`, *default:* `nil`) - The [HTTP entity tag](https://en.wikipedia.org/wiki/HTTP_ETag) of the resource. Used for web cache validation.
  *   `formattedName` (*type:* `String.t`, *default:* `nil`) - Output only. The name translated and formatted in the viewer's account locale or the `Accept-Language` HTTP header locale for system groups names. Group names set by the owner are the same as name.
  *   `groupType` (*type:* `String.t`, *default:* `nil`) - Output only. The contact group type.
  *   `memberCount` (*type:* `integer()`, *default:* `nil`) - Output only. The total number of contacts in the group irrespective of max members in specified in the request.
  *   `memberResourceNames` (*type:* `list(String.t)`, *default:* `nil`) - Output only. The list of contact person resource names that are members of the contact group. The field is only populated for GET requests and will only return as many members as `maxMembers` in the get request.
  *   `metadata` (*type:* `GoogleApi.People.V1.Model.ContactGroupMetadata.t`, *default:* `nil`) - Output only. Metadata about the contact group.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The contact group name set by the group owner or a system provided name for system groups. For [`contactGroups.create`](/people/api/rest/v1/contactGroups/create) or [`contactGroups.update`](/people/api/rest/v1/contactGroups/update) the name must be unique to the users contact groups. Attempting to create a group with a duplicate name will return a HTTP 409 error.
  *   `resourceName` (*type:* `String.t`, *default:* `nil`) - The resource name for the contact group, assigned by the server. An ASCII string, in the form of `contactGroups/{contact_group_id}`.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :clientData => list(GoogleApi.People.V1.Model.GroupClientData.t()) | nil,
          :etag => String.t() | nil,
          :formattedName => String.t() | nil,
          :groupType => String.t() | nil,
          :memberCount => integer() | nil,
          :memberResourceNames => list(String.t()) | nil,
          :metadata => GoogleApi.People.V1.Model.ContactGroupMetadata.t() | nil,
          :name => String.t() | nil,
          :resourceName => String.t() | nil
        }

  field(:clientData, as: GoogleApi.People.V1.Model.GroupClientData, type: :list)
  field(:etag)
  field(:formattedName)
  field(:groupType)
  field(:memberCount)
  field(:memberResourceNames, type: :list)
  field(:metadata, as: GoogleApi.People.V1.Model.ContactGroupMetadata)
  field(:name)
  field(:resourceName)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.ContactGroup do
  def decode(value, options) do
    GoogleApi.People.V1.Model.ContactGroup.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.ContactGroup do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
