# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.CopyOtherContactToMyContactsGroupRequest do
  @moduledoc """
  A request to copy an "Other contact" to my contacts group.

  ## Attributes

  *   `copyMask` (*type:* `String.t`, *default:* `nil`) - Required. A field mask to restrict which fields are copied into the new contact. Valid values are: * emailAddresses * names * phoneNumbers
  *   `readMask` (*type:* `String.t`, *default:* `nil`) - Optional. A field mask to restrict which fields on the person are returned. Multiple fields can be specified by separating them with commas. Defaults to the copy mask with metadata and membership fields if not set. Valid values are: * addresses * ageRanges * biographies * birthdays * calendarUrls * clientData * coverPhotos * emailAddresses * events * externalIds * genders * imClients * interests * locales * locations * memberships * metadata * miscKeywords * names * nicknames * occupations * organizations * phoneNumbers * photos * relations * sipAddresses * skills * urls * userDefined
  *   `sources` (*type:* `list(String.t)`, *default:* `nil`) - Optional. A mask of what source types to return. Defaults to READ_SOURCE_TYPE_CONTACT and READ_SOURCE_TYPE_PROFILE if not set.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :copyMask => String.t() | nil,
          :readMask => String.t() | nil,
          :sources => list(String.t()) | nil
        }

  field(:copyMask)
  field(:readMask)
  field(:sources, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.CopyOtherContactToMyContactsGroupRequest do
  def decode(value, options) do
    GoogleApi.People.V1.Model.CopyOtherContactToMyContactsGroupRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.CopyOtherContactToMyContactsGroupRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
