# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.CreateContactGroupRequest do
  @moduledoc """
  A request to create a new contact group.

  ## Attributes

  *   `contactGroup` (*type:* `GoogleApi.People.V1.Model.ContactGroup.t`, *default:* `nil`) - Required. The contact group to create.
  *   `readGroupFields` (*type:* `String.t`, *default:* `nil`) - Optional. A field mask to restrict which fields on the group are returned. Defaults to `metadata`, `groupType`, and `name` if not set or set to empty. Valid fields are: * clientData * groupType * metadata * name
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :contactGroup => GoogleApi.People.V1.Model.ContactGroup.t() | nil,
          :readGroupFields => String.t() | nil
        }

  field(:contactGroup, as: GoogleApi.People.V1.Model.ContactGroup)
  field(:readGroupFields)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.CreateContactGroupRequest do
  def decode(value, options) do
    GoogleApi.People.V1.Model.CreateContactGroupRequest.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.CreateContactGroupRequest do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
