# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.ImClient do
  @moduledoc """
  A person's instant messaging client.

  ## Attributes

  *   `formattedProtocol` (*type:* `String.t`, *default:* `nil`) - Output only. The protocol of the IM client formatted in the viewer's account locale or the `Accept-Language` HTTP header locale.
  *   `formattedType` (*type:* `String.t`, *default:* `nil`) - Output only. The type of the IM client translated and formatted in the viewer's account locale or the `Accept-Language` HTTP header locale.
  *   `metadata` (*type:* `GoogleApi.People.V1.Model.FieldMetadata.t`, *default:* `nil`) - Metadata about the IM client.
  *   `protocol` (*type:* `String.t`, *default:* `nil`) - The protocol of the IM client. The protocol can be custom or one of these predefined values: * `aim` * `msn` * `yahoo` * `skype` * `qq` * `googleTalk` * `icq` * `jabber` * `netMeeting`
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the IM client. The type can be custom or one of these predefined values: * `home` * `work` * `other`
  *   `username` (*type:* `String.t`, *default:* `nil`) - The user name used in the IM client.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :formattedProtocol => String.t() | nil,
          :formattedType => String.t() | nil,
          :metadata => GoogleApi.People.V1.Model.FieldMetadata.t() | nil,
          :protocol => String.t() | nil,
          :type => String.t() | nil,
          :username => String.t() | nil
        }

  field(:formattedProtocol)
  field(:formattedType)
  field(:metadata, as: GoogleApi.People.V1.Model.FieldMetadata)
  field(:protocol)
  field(:type)
  field(:username)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.ImClient do
  def decode(value, options) do
    GoogleApi.People.V1.Model.ImClient.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.ImClient do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
