# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.ListContactGroupsResponse do
  @moduledoc """
  The response to a list contact groups request.

  ## Attributes

  *   `contactGroups` (*type:* `list(GoogleApi.People.V1.Model.ContactGroup.t)`, *default:* `nil`) - The list of contact groups. Members of the contact groups are not populated.
  *   `nextPageToken` (*type:* `String.t`, *default:* `nil`) - The token that can be used to retrieve the next page of results.
  *   `nextSyncToken` (*type:* `String.t`, *default:* `nil`) - The token that can be used to retrieve changes since the last request.
  *   `totalItems` (*type:* `integer()`, *default:* `nil`) - The total number of items in the list without pagination.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :contactGroups => list(GoogleApi.People.V1.Model.ContactGroup.t()) | nil,
          :nextPageToken => String.t() | nil,
          :nextSyncToken => String.t() | nil,
          :totalItems => integer() | nil
        }

  field(:contactGroups, as: GoogleApi.People.V1.Model.ContactGroup, type: :list)
  field(:nextPageToken)
  field(:nextSyncToken)
  field(:totalItems)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.ListContactGroupsResponse do
  def decode(value, options) do
    GoogleApi.People.V1.Model.ListContactGroupsResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.ListContactGroupsResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
