# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.Location do
  @moduledoc """
  A person's location.

  ## Attributes

  *   `buildingId` (*type:* `String.t`, *default:* `nil`) - The building identifier.
  *   `current` (*type:* `boolean()`, *default:* `nil`) - Whether the location is the current location.
  *   `deskCode` (*type:* `String.t`, *default:* `nil`) - The individual desk location.
  *   `floor` (*type:* `String.t`, *default:* `nil`) - The floor name or number.
  *   `floorSection` (*type:* `String.t`, *default:* `nil`) - The floor section in `floor_name`.
  *   `metadata` (*type:* `GoogleApi.People.V1.Model.FieldMetadata.t`, *default:* `nil`) - Metadata about the location.
  *   `type` (*type:* `String.t`, *default:* `nil`) - The type of the location. The type can be custom or one of these predefined values: * `desk` * `grewUp`
  *   `value` (*type:* `String.t`, *default:* `nil`) - The free-form value of the location.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :buildingId => String.t() | nil,
          :current => boolean() | nil,
          :deskCode => String.t() | nil,
          :floor => String.t() | nil,
          :floorSection => String.t() | nil,
          :metadata => GoogleApi.People.V1.Model.FieldMetadata.t() | nil,
          :type => String.t() | nil,
          :value => String.t() | nil
        }

  field(:buildingId)
  field(:current)
  field(:deskCode)
  field(:floor)
  field(:floorSection)
  field(:metadata, as: GoogleApi.People.V1.Model.FieldMetadata)
  field(:type)
  field(:value)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.Location do
  def decode(value, options) do
    GoogleApi.People.V1.Model.Location.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.Location do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
