# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.People.V1.Model.ModifyContactGroupMembersResponse do
  @moduledoc """
  The response to a modify contact group members request.

  ## Attributes

  *   `canNotRemoveLastContactGroupResourceNames` (*type:* `list(String.t)`, *default:* `nil`) - The contact people resource names that cannot be removed from their last contact group.
  *   `notFoundResourceNames` (*type:* `list(String.t)`, *default:* `nil`) - The contact people resource names that were not found.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :canNotRemoveLastContactGroupResourceNames => list(String.t()) | nil,
          :notFoundResourceNames => list(String.t()) | nil
        }

  field(:canNotRemoveLastContactGroupResourceNames, type: :list)
  field(:notFoundResourceNames, type: :list)
end

defimpl Poison.Decoder, for: GoogleApi.People.V1.Model.ModifyContactGroupMembersResponse do
  def decode(value, options) do
    GoogleApi.People.V1.Model.ModifyContactGroupMembersResponse.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.People.V1.Model.ModifyContactGroupMembersResponse do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
